Subject: Re-implement Accept Header / Content Negotiation support
Description

The older implementation is fairly limited to a single specific media type and also uses the old MIME terminology.

An improved implementation should be

    -  well integrated into the new HTTP support
    -  consider Quality Values while analyzing the Accept header
    -  use the new Internet Media Type terminology
    -  well tested

Related issues:
related to TYPO3.Flow - Feature # 10680: Implement Content Negotiation Support Resolved 2010-11-08

Associated revisions
Revision 03b6d859 - 2012-05-30 11:24 - Robert Lemke

[!!!][FEATURE] Content Negotiation for Media Types

This improves the support for detecting the Media
Type (that is, "format" in an ActionRequest context)
based on the request's Accept header.

This implementation supports Quality Values and Media
Ranges as specified in RFC 2616.

The way to define the supported formats of a controller
has changed: Previously a class property $supportedFormats
contained a list of filename extensions which would be
supported. This property is not supported anymore.
Instead, controllers may now specify a list of IANA
Internet Media Types in a property $supportedMediaTypes.

The default setting for these supported media types
in ActionController is "text/html". You'll need to adjust
your controllers accordingly if you relied on the
$supportedFormats feature.

Also note that the format in ActionRequest is now NULL
by default. The ActionController makes sure to set the
correct format, but if you created your own ActionRequest
for a special purpose, you need to take care of setting
it yourself.

Change-Id: I7d753155aa72f41e3df85b076e8067bcbfe7ac04
Resolves: #37561
Releases: 1.1, 1.2

Revision 29618c52 - 2012-05-30 18:06 - Robert Lemke

[!!!][FEATURE] Content Negotiation for Media Types

This improves the support for detecting the Media
Type (that is, "format" in an ActionRequest context)
based on the request's Accept header.

This implementation supports Quality Values and Media
Ranges as specified in RFC 2616.

The way to define the supported formats of a controller
has changed: Previously a class property $supportedFormats
contained a list of filename extensions which would be
supported. This property is not supported anymore.
Instead, controllers may now specify a list of IANA
Internet Media Types in a property $supportedMediaTypes.

The default setting for these supported media types
in ActionController is "text/html". You'll need to adjust
your controllers accordingly if you relied on the
$supportedFormats feature.

Also note that the format in ActionRequest is now NULL
by default. The ActionController makes sure to set the
correct format, but if you created your own ActionRequest
for a special purpose, you need to take care of setting
it yourself.

Change-Id: I7d753155aa72f41e3df85b076e8067bcbfe7ac04
Resolves: #37561
Releases: 1.1, 1.2

History
#1 - 2012-05-29 11:29 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11683

#2 - 2012-05-29 18:18 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11683

#3 - 2012-05-29 18:30 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11683

#4 - 2012-05-29 22:14 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11683

#5 - 2012-05-29 22:42 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11683

#6 - 2012-05-29 22:56 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11683

#7 - 2012-05-30 12:04 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11683

#8 - 2012-05-30 12:38 - Robert Lemke
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:03b6d85916e46ed8b2e99bc549d7248957dca935.

#9 - 2012-05-30 12:42 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/11727

#10 - 2012-05-30 14:26 - Gerrit Code Review

Patch set 2 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/11727
#11 - 2012-05-30 17:23 - Gerrit Code Review

Patch set 3 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/11727

#12 - 2012-05-30 18:09 - Gerrit Code Review

Patch set 4 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/11727

#13 - 2012-05-30 20:38 - Robert Lemke
- Status changed from Under Review to Resolved

Applied in changeset commit:29618c52b31a51acb1ddc4fb7796dfdab909cafe.
